/**
 * Dragon - SOA Governance Platform.
 * Copyright (c) 2008 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * EnvironmentFederation.java
 * -------------------------------------------------------------------------
 */

package org.ow2.dragon.connection.api.to;

import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlElements;
import javax.xml.bind.annotation.XmlType;

/**
 * A Federation is group of linked Execution Environments. Examples of
 * Federation: Federated or Distributed ESB, Grid, etc.
 * 
 * @author ofabre - eBM Websourcing
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(namespace = "http://to.api.connection.dragon.ow2.org/", name = "EnvironmentFederation")
public class EnvironmentFederation {

    public enum FedPattern {
        HUB_AND_SPOKE, FEDERATED, GRID, DISTRIBUTED
    }

    @XmlAttribute(name = "name")
    private String name;

    @XmlAttribute(name = "pattern")
    private FedPattern pattern;

    @XmlElementWrapper(name = "possibleRoles")
    @XmlElements( { @XmlElement(name = "possibleRoles", type = String.class) })
    private List<String> possibleRole;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public FedPattern getPattern() {
        return pattern;
    }

    public void setPattern(FedPattern pattern) {
        this.pattern = pattern;
    }

    public List<String> getPossibleRole() {
        return possibleRole;
    }

    public void setPossibleRole(List<String> possibleRole) {
        this.possibleRole = possibleRole;
    }

}
