/**
 * Dragon - SOA Governance Platform.
 * Copyright (c) 2008 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * ExecutionEnvironment.java
 * -------------------------------------------------------------------------
 */

package org.ow2.dragon.connection.api.to;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;

/**
 * An Execution Environment is a software that could expose services. Examples
 * of execution environments: Application Server (JBoss, Jonas, WebSphere,
 * etc.), ESB (PEtALS, ServiceMix, OpenESB, JBoss ESB, etc.).
 * 
 * @author ofabre - eBM Websourcing
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(namespace = "http://to.api.connection.dragon.ow2.org/", name = "ExecutionEnvironment")
public class ExecutionEnvironment extends Node {

    public enum EEType {
        ESB, APPLICATION_SERVER, CLIENT, WEB_SERVER
    }

    @XmlAttribute(name = "envType")
    private EEType envType;

    @XmlAttribute(name = "roleInFederation")
    private String roleInFederation;

    @XmlElement(name = "hostProcessor")
    private Processor hostProcessor;

    @XmlElement(name = "parentFederation")
    private EnvironmentFederation parentFederation;

    public EEType getEnvType() {
        return this.envType;
    }

    public Processor getHostProcessor() {
        return this.hostProcessor;
    }

    public EnvironmentFederation getParentFederation() {
        return this.parentFederation;
    }

    public String getRoleInFederation() {
        return this.roleInFederation;
    }

    public void setEnvType(final EEType envType) {
        this.envType = envType;
    }

    public void setHostProcessor(final Processor hostProcessor) {
        this.hostProcessor = hostProcessor;
    }

    public void setParentFederation(final EnvironmentFederation parentFederation) {
        this.parentFederation = parentFederation;
    }

    public void setRoleInFederation(final String roleInFederation) {
        this.roleInFederation = roleInFederation;
    }

}
